Index: /branches/multichoice/examples/mapviewer/select/select_feature_example.tcl
===================================================================
--- /branches/multichoice/examples/mapviewer/select/select_feature_example.tcl	(revision 6370)
+++ /branches/multichoice/examples/mapviewer/select/select_feature_example.tcl	(revision 6371)
@@ -1,2 +1,3 @@
+package require Tk
 package require Rappture
 package require RapptureGUI
@@ -7,38 +8,49 @@
 source [file join $commondir geovis_settings.tcl]
 
-# this method is called when a user clicks on a icon in the map
-# the method is used at the bottom of this example
-# the callback is called with two arguments:
-# option - should be one of "annotation", "clear", "feature"
-proc handler {option {args ""}} {
+# This method is called when a user modifies the selection in the map view.
+# This callback is installed in the viewer using setSelectCallback in the code below.
+# The callback has two arguments:
+#   option - should be one of "annotation", "clear", "feature", "region"
+#   args - depends on option, see below
+proc selectHandler {option {args ""}} {
     switch $option {
         "annotation" {
-            # pass
+            # An annotation (not in a feature layer) was selected, the single argument
+            # is a list of the selected annotation names.
         }
         "clear" {
-            # previously selected features have been unselected.
-            # no arguments associated with this option.
+            # Previously selected features or annotations have been deselected.
+            # No arguments.
+            puts "select clear"
         }
         "feature" {
-            # a feature was selected, the server returns 4 values about the feature
-            # that are held in args:
-            # globalObjId - the global object identifier
-            # featureIdList - a single value or list of feature identifiers.
-            #                 if multiple features are returned, they arei
-            #                 enclosed in curly brackets.
-            # numFeaturesInLayer - the number of features in the layer
-            # layerName - the name of the layer the features were found in.
-            #             only features from a single layer can be selected
-            #             at a time.
-            foreach {globalObjId featureIdList numFeaturesInLayer layerName} $args break
-            puts "handler caught\
-                globalObjId=\"$globalObjId\"\
-                featureIdList=\"$featureIdList\"\
-                numFeaturesInLayer=\"$numFeaturesInLayer\"\
-                layerName=\"$layerName\""
+            # The feature selection set changed, the arguments are:
+            #   op - "add", "delete" or "set"
+            #   featureIdList - a list of feature identifiers.
+            #   layerName - the name of the layer the features were found in.
+            foreach {op featureIdList layerName} $args break
+            switch $op {
+                "add" {
+                    puts "select feature add:\nfeatureIDList=\"$featureIdList\"\nlayerName=\"$layerName\""
+                }
+                "delete" {
+                    puts "select feature delete:\nfeatureIDList=\"$featureIdList\"\nlayerName=\"$layerName\""
+                }
+                "set" {
+                    puts "select feature set:\nfeatureIDList=\"$featureIdList\"\nlayerName=\"$layerName\""
+                }
+                default {
+                    error "bad op \"$op\": should be one of: add, delete or set"
+                }
+            }
+        }
+        "region" {
+            # An area defined by two wgs84 corner points was selected.
+            # Here x is wgs84 decimal degrees longitude and y is wgs84 decimal degrees latitude.
+            foreach {xmin ymin xmax ymax} $args break
+            puts "select region: ($xmin, $ymin) - ($xmax, $ymax)"
         }
         default {
-            error "bad option \"$option\": should be one of annotation,\
-                clean, or feature"
+            error "bad option \"$option\": should be one of: annotation, clear, feature or region"
         }
     }
@@ -87,8 +99,8 @@
 "
 
-# create a map object
+# Create a map object
 set map [Rappture::Map #auto]
 
-# add all layers to the map object
+# Add all layers to the map object
 $map addLayer image \
     osm [array get osmParams] \
@@ -102,13 +114,13 @@
     $stylesheet
 
-# add a map to the vis client
+# Add a map to the vis client
 $mapviewer scale $map
 $mapviewer add $map
 
 
-# set the proc/method to be called when a feature is selected on the map.
-# in this case we give the full path to the previously defined
-# procedure named "handler". for an itcl class method, you may need to
-# use itcl::code to get the full path of the  callback method:
-# for example: [itcl::code $this handler]
-$mapviewer setSelectCallback ::handler
+# Set the proc/method to be called when a feature is selected on the map.
+# In this case we give the full path to the previously defined
+# procedure named "selectHandler". For an itcl class method, you may need to
+# use itcl::code to get the full path of the callback method, e.g.
+# [itcl::code $this selectHandler]
+$mapviewer setSelectCallback ::selectHandler
Index: /branches/multichoice/examples/mapviewer/tms/tms_example.tcl
===================================================================
--- /branches/multichoice/examples/mapviewer/tms/tms_example.tcl	(revision 6370)
+++ /branches/multichoice/examples/mapviewer/tms/tms_example.tcl	(revision 6371)
@@ -1,2 +1,3 @@
+package require Tk
 package require Rappture
 package require RapptureGUI
Index: /branches/multichoice/examples/mapviewer/wms/wms_example.tcl
===================================================================
--- /branches/multichoice/examples/mapviewer/wms/wms_example.tcl	(revision 6370)
+++ /branches/multichoice/examples/mapviewer/wms/wms_example.tcl	(revision 6371)
@@ -1,2 +1,3 @@
+package require Tk
 package require Rappture
 package require RapptureGUI
Index: /branches/multichoice/examples/mapviewer/xyz/xyz_example.tcl
===================================================================
--- /branches/multichoice/examples/mapviewer/xyz/xyz_example.tcl	(revision 6370)
+++ /branches/multichoice/examples/mapviewer/xyz/xyz_example.tcl	(revision 6371)
@@ -1,2 +1,3 @@
+package require Tk
 package require Rappture
 package require RapptureGUI
Index: /branches/multichoice/gui/apps/launcher.tcl
===================================================================
--- /branches/multichoice/gui/apps/launcher.tcl	(revision 6370)
+++ /branches/multichoice/gui/apps/launcher.tcl	(revision 6371)
@@ -42,4 +42,6 @@
 set params(execute) ""
 set params(input) ""
+
+set rapptureInfo(cwd) [pwd]
 
 if {[info exists env(TOOL_PARAMETERS)]} {
Index: /branches/multichoice/gui/scripts/controls.tcl
===================================================================
--- /branches/multichoice/gui/scripts/controls.tcl	(revision 6370)
+++ /branches/multichoice/gui/scripts/controls.tcl	(revision 6371)
@@ -178,4 +178,7 @@
         drawing {
             Rappture::DrawingEntry $w $_owner $path
+        }
+        map {
+            Rappture::MapEntry $w $_owner $path
         }
         image {
@@ -280,5 +283,5 @@
     $_owner widgetfor $path $w
 
-    if {[lsearch {control group drawing separator note} $type] < 0} {
+    if {[lsearch {control group drawing map separator note} $type] < 0} {
         # make a label for this control
         set label [$w label]
Index: /branches/multichoice/gui/scripts/flowvisviewer.tcl
===================================================================
--- /branches/multichoice/gui/scripts/flowvisviewer.tcl	(revision 6370)
+++ /branches/multichoice/gui/scripts/flowvisviewer.tcl	(revision 6371)
@@ -127,24 +127,24 @@
 
     private variable _arcball ""
-    private variable _dlist ""         ;# list of data objects
-    private variable _obj2ovride       ;# maps dataobj => style override
-    private variable _datasets         ;# contains all the dataobj-component
-                                       ;# to volumes in the server
-    private variable _dataset2style    ;# maps dataobj-component to transfunc
-    private variable _style2datasets   ;# maps tf back to list of
+    private variable _dlist "";         # list of data objects
+    private variable _obj2ovride;       # maps dataobj => style override
+    private variable _datasets;         # maps dataobj-component
+                                        # to volumes in the server
+    private variable _dataset2style;    # maps dataobj-component to transfunc
+    private variable _style2datasets;   # maps tf back to list of
                                         # dataobj-components using the tf.
-    private variable _dataset2flow     ;# Maps dataobj-component to a flow.
-
-    private variable _reset 1          ;# Connection to server has been reset.
-    private variable _click            ;# Info used for rotate operations.
-    private variable _limits           ;# Autoscale min/max for all axes
-    private variable _view             ;# View params for 3D view
-    private variable _isomarkers       ;# array of isosurface level values 0..1
+    private variable _dataset2flow;     # Maps dataobj-component to a flow.
+
+    private variable _reset 1;          # Connection to server has been reset.
+    private variable _click;            # Info used for rotate operations.
+    private variable _limits;           # Autoscale min/max for all axes
+    private variable _view;             # View params for 3D view
+    private variable _isomarkers;       # array of isosurface level values 0..1
     private variable _settings
-    private variable _activeTf ""      ;# Currently active transfer function
-    private variable _first ""         ;# This is the topmost volume.
-    private variable _volcomponents    ;# Maps component name to list of
-                                       ;# dataobj-component tags
-    private variable _componentsList   ;# List of components found
+    private variable _activeTf "";      # Currently active transfer function
+    private variable _first "";         # This is the topmost volume.
+    private variable _volcomponents;    # Maps component name to list of
+                                        # dataobj-component tags
+    private variable _componentsList;   # List of components found
     private variable _nextToken 0
     private variable _icon 0
@@ -156,5 +156,5 @@
     private variable _gotoPending 0
 
-    private common _downloadPopup      ;# download options from popup
+    private common _downloadPopup;      # download options from popup
     private common _hardcopy
 }
@@ -641,5 +641,5 @@
     set op [lindex $args 0]
     switch -- $op {
-        -objects {
+        "-objects" {
             # put the dataobj list in order according to -raise options
             set dlist $_dlist
@@ -656,5 +656,5 @@
             return $dlist
         }
-        -image {
+        "-image" {
             if {[llength $args] != 2} {
                 error "wrong # args: should be \"get -image view|legend\""
@@ -1095,5 +1095,7 @@
         DoResize
     }
-
+    if { $_reset } {
+        InitSettings -background -axesvisible -gridvisible
+    }
     set _first ""
     foreach dataobj [get -objects] {
@@ -1148,6 +1150,5 @@
 
     if { $_reset } {
-        InitSettings -axesvisible -gridvisible \
-            -opacity -light2side -isosurfaceshading \
+        InitSettings -opacity -light2side -isosurfaceshading \
             -ambient -diffuse -specularlevel -specularexponent
 
@@ -2815,5 +2816,5 @@
     radiobutton $inner.image_button -text "Image File" \
         -variable [itcl::scope _downloadPopup(format)] \
-        -font "Arial 9 " \
+        -font "Arial 9" \
         -value image
     Rappture::Tooltip::for $inner.image_button \
Index: /branches/multichoice/gui/scripts/gauge.tcl
===================================================================
--- /branches/multichoice/gui/scripts/gauge.tcl	(revision 6370)
+++ /branches/multichoice/gui/scripts/gauge.tcl	(revision 6371)
@@ -636,4 +636,7 @@
     $itk_component(spindn) configure -state $itk_option(-state)
     $itk_component(presets) configure -state $itk_option(-state)
+    if { [info exists itk_component(uq)] } {
+        $itk_component(uq) configure -state $itk_option(-state)
+    }
     _redraw  ;# fix gauge
 }
@@ -756,5 +759,5 @@
 
         $popup configure \
-        -deactivatecommand [itcl::code $this _pop_uq_deactivate]
+            -deactivatecommand [itcl::code $this _pop_uq_deactivate]
     }
     update
Index: /branches/multichoice/gui/scripts/map.tcl
===================================================================
--- /branches/multichoice/gui/scripts/map.tcl	(revision 6370)
+++ /branches/multichoice/gui/scripts/map.tcl	(revision 6371)
@@ -31,8 +31,21 @@
 
     public method addLayer { type name paramArray driver driverParamArray {stylesheet {}} {script {}} {selectors {}} }
+    public method addSelector { layerName selectorName paramArray }
     public method addViewpoint { name props }
     public method clearExtents {}
     public method deleteLayer { layerName }
+    public method deleteSelector { layerName selectorName }
     public method deleteViewpoint { viewpointName }
+    public method dirty { key args } {
+        if {[llength $args] == 0} {
+            if { [info exists _dirty($key)] } {
+                return $_dirty($key)
+            } else {
+                return 0
+            }
+        } else {
+            set _dirty($key) [lindex $args 0]
+        }
+    }
     public method getPlacardConfig { layerName }
     public method hasLayer { layerName }
@@ -50,9 +63,13 @@
     public method setAttribution { attribution }
     public method setCamera { camera }
+    public method setColormap { layerName colormap }
+    public method setDescription { description }
     public method setExtents { xmin ymin xmax ymax {srs "wgs84"} }
     public method setLabel { label }
     public method setPlacardConfig { layerName attrlist style padding }
     public method setProjection { projection }
+    public method setScript { layerName script }
     public method setStyle { style }
+    public method setStylesheet { layerName stylesheet }
     public method setToolInfo { id name command title revision }
     public method setType { type }
@@ -69,4 +86,8 @@
     private variable _tree "";         # Tree of information about the map.
     private variable _isValid 0;
+    private variable _dirty;
+    array set _dirty {
+        viewpoints 0
+    }
     private common _nextSelector 0;
     private common _layerTypes
@@ -147,4 +168,5 @@
     # Set global map properties
     setLabel [$map get "about.label"]
+    setDescription [$map get "about.description"]
     setAttribution [$map get "about.attribution"]
 
@@ -506,4 +528,8 @@
 }
 
+itcl::body Rappture::Map::setDescription { description } {
+    $_tree set root "description" $description
+}
+
 itcl::body Rappture::Map::setAttribution { attribution } {
     $_tree set root "attribution" $attribution
@@ -623,9 +649,9 @@
             array set selector $selectorItem
             if { [info exists selector(id)] } {
-                set id $selector(id)
+                set selectorId $selector(id)
             } else {
-                set id "selector[incr _nextSelector]"
-            }
-            set snode [$_tree insert $sparent -label $id]
+                set selectorId "selector[incr _nextSelector]"
+            }
+            set snode [$_tree insert $sparent -label $selectorId]
             foreach key { name style styleExpression query queryBounds queryOrderBy } {
                 if {[info exists selector($key)]} {
@@ -759,4 +785,5 @@
         }
     }
+    set _dirty($id) 1
     return $id
 }
@@ -798,4 +825,5 @@
     }
     $_tree delete $id
+    array unset _dirty $layerName
 }
 
@@ -862,4 +890,31 @@
 }
 
+itcl::body Rappture::Map::setScript { layerName script } {
+    set id [$_tree findchild root->"layers" $layerName]
+    if { $id < 0 } {
+        error "unknown layer \"$layerName\""
+    }
+    $_tree set $id "script" $script
+    set _dirty($layerName) 1
+}
+
+itcl::body Rappture::Map::setStylesheet { layerName stylesheet } {
+    set id [$_tree findchild root->"layers" $layerName]
+    if { $id < 0 } {
+        error "unknown layer \"$layerName\""
+    }
+    $_tree set $id "stylesheet" $stylesheet
+    set _dirty($layerName) 1
+}
+
+itcl::body Rappture::Map::setColormap { layerName colormap } {
+    set id [$_tree findchild root->"layers" $layerName]
+    if { $id < 0 } {
+        error "unknown layer \"$layerName\""
+    }
+    $_tree set $id "colorramp.colormap" $colormap
+    set _dirty($layerName) 1
+}
+
 # ----------------------------------------------------------------------
 # USAGE: selectors
@@ -898,4 +953,37 @@
         return 1
     }
+}
+
+itcl::body Rappture::Map::addSelector { layerName name params } {
+    set nodeid $name
+    set layerid [$_tree findchild root->"layers" $layerName]
+    if { $layerid < 0 } {
+        error "unknown layer \"$layerName\""
+    }
+    if {[hasSelector $layerName $nodeid]} {
+        error "Selector '$nodeid' already exists"
+    }
+    set parent [$_tree findchild root->"layers"->"$layerName" "selectors"]
+    if { $parent == "" } {
+        set parent [$_tree insert $layerid -label "selectors"]
+    }
+    set child [$_tree insert $parent -label $nodeid]
+    array set info $params
+    foreach key { name style styleExpression query queryBounds queryOrderBy } {
+        if { [info exists info($key)] &&
+             $info($key) != ""} {
+            $_tree set $child $key $info($key)
+        }
+    }
+    set _dirty($layerName) 1
+}
+
+itcl::body Rappture::Map::deleteSelector { layerName selectorName } {
+    set id [$_tree findchild root->"layers"->"$layerName"->"selectors" $selectorName]
+    if { $id < 0 } {
+        error "unknown selector \"$selectorName\""
+    }
+    $_tree delete $id
+    set _dirty($layerName) 1
 }
 
@@ -965,4 +1053,5 @@
         $_tree set $child z $info(altitude)
     }
+    set _dirty(viewpoints) 1
 }
 
@@ -973,4 +1062,5 @@
     }
     $_tree delete $id
+    set _dirty(viewpoints) 1
 }
 
Index: /branches/multichoice/gui/scripts/mapentry.tcl
===================================================================
--- /branches/multichoice/gui/scripts/mapentry.tcl	(revision 6371)
+++ /branches/multichoice/gui/scripts/mapentry.tcl	(revision 6371)
@@ -0,0 +1,136 @@
+# -*- mode: tcl; indent-tabs-mode: nil -*-
+# ----------------------------------------------------------------------
+#  COMPONENT: MapEntry - widget for viewing map as input control
+#
+# ======================================================================
+#  AUTHOR:  Leif Delgass, Purdue University
+#  Copyright (c) 2016  HUBzero Foundation, LLC
+#
+#  See the file "license.terms" for information on usage and
+#  redistribution of this file, and for a DISCLAIMER OF ALL WARRANTIES.
+# ======================================================================
+package require Itk
+
+itcl::class Rappture::MapEntry {
+    inherit itk::Widget
+
+    itk_option define -state state State "normal"
+
+    constructor {owner path args} {
+        # defined below
+    }
+    public method label {}
+    public method tooltip {}
+    public method value {args}
+
+    private variable _owner ""      ;# thing managing this control
+    private variable _path ""       ;# path in XML to this input
+    private variable _xmlobj ""
+    private variable _mapviewer ""  ;# MapViewer widget
+}
+
+itk::usual MapEntry {
+}
+
+# ----------------------------------------------------------------------
+# CONSTRUCTOR
+# ----------------------------------------------------------------------
+itcl::body Rappture::MapEntry::constructor {owner path args} {
+    if {[catch {$owner isa Rappture::ControlOwner} valid] != 0 || !$valid} {
+        error "bad object \"$owner\": should be Rappture::ControlOwner"
+    }
+    set _owner $owner
+    set _path $path
+    set _xmlobj [$_owner xml object]
+
+    itk_component add map {
+        Rappture::MapViewer $itk_interior.map
+    }
+    pack $itk_component(map) -expand yes -fill both
+    set _mapviewer $itk_component(map)
+
+    eval itk_initialize $args
+
+    value $_xmlobj
+}
+
+# ----------------------------------------------------------------------
+# USAGE: value ?-check? ?<newval>?
+#
+# Clients use this to query/set the value for this widget.  With
+# no args, it returns the current value for the widget.  If the
+# <newval> is specified, it sets the value of the widget and
+# sends a <<Value>> event.  If the -check flag is included, the
+# new value is not actually applied, but just checked for correctness.
+# ----------------------------------------------------------------------
+itcl::body Rappture::MapEntry::value {args} {
+    set onlycheck 0
+    set i [lsearch -exact $args -check]
+    if {$i >= 0} {
+        set onlycheck 1
+        set args [lreplace $args $i $i]
+    }
+
+    if {[llength $args] == 1} {
+        set newval [lindex $args 0]
+
+        if {!$onlycheck && $_xmlobj != "" && $_xmlobj != $newval} {
+            # delete any existing object
+            itcl::delete object $_xmlobj
+            set _xmlobj ""
+        }
+        if {$newval != ""} {
+            if {![Rappture::library isvalid $newval]} {
+                error "bad value \"$newval\": should be Rappture::Library"
+            }
+            if {$onlycheck} {
+                return
+            }
+            set _xmlobj $newval
+        }
+        set dataobjs [$_mapviewer get]
+        $_mapviewer configure -map [Rappture::Map ::#auto $_xmlobj $_path]
+        foreach dataobj $dataobjs {
+            itcl::delete object $dataobj
+        }
+        event generate $itk_component(hull) <<Value>>
+    } elseif {[llength $args] != 0} {
+        error "wrong # args: should be \"value ?-check? ?newval?\""
+    }
+    return ""
+}
+
+# ----------------------------------------------------------------------
+# USAGE: label
+#
+# Clients use this to query the label associated with this widget.
+# Reaches into the XML and pulls out the appropriate label string.
+# ----------------------------------------------------------------------
+itcl::body Rappture::MapEntry::label {} {
+    set label [string trim [$_owner xml get $_path.about.label]]
+    return $label
+}
+
+# ----------------------------------------------------------------------
+# USAGE: tooltip
+#
+# Clients use this to query the tooltip associated with this widget.
+# Reaches into the XML and pulls out the appropriate description
+# string.  Returns the string that should be used with the
+# Rappture::Tooltip facility.
+# ----------------------------------------------------------------------
+itcl::body Rappture::MapEntry::tooltip {} {
+    set str [string trim [$_owner xml get $_path.about.description]]
+    return $str
+}
+
+# ----------------------------------------------------------------------
+# CONFIGURATION OPTION: -state
+# ----------------------------------------------------------------------
+itcl::configbody Rappture::MapEntry::state {
+    set valid {normal disabled}
+    if {[lsearch -exact $valid $itk_option(-state)] < 0} {
+        error "bad value \"$itk_option(-state)\": should be [join $valid {, }]"
+    }
+    #$_mapviewer configure -state $itk_option(-state)
+}
